<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class Admin_PluginController extends Controller
{
    /**
    * set access privileges
    */   
    function init()
    {        
        $this->acl->allow('administrator', $this->name, "*");
         
        if(!$this->acl->isAllowed($this->session->get("role"), $this->name, $this->action))
        {
            $this->redirect(FrontController::getRewrittedUrl("/admin/main/logIn"));  
        }
    }   

    /**
    * Get available plugins in /plugin directory
    */
    function getAvailablePlugins()
    {
        $plugins = array(); 
        $dir = new DirectoryIterator(CODE_ROOT_DIR.'plugins/');
        
        foreach($dir as $file)
        {
            if(!$file->isDot() && $file->isDir())
            { 
                $plugins[] = $file->getFilename();
            }
        }
        
        return $plugins;
    }
    
    /**
    * Show plugin details
    */
    function editAction($pluginName)
    {
        $pluginName = basename($pluginName);
        $pluginRootPath = CODE_ROOT_DIR."plugins/".$pluginName."/";
        
        $descriptionPath = $pluginRootPath."info.txt"; 
        $pluginDescription = file_exists($descriptionPath) ? file_get_contents($descriptionPath) : "";
        
        $functionsPath = $pluginRootPath."functions.xml";
        $pluginFunctions = array();
        
        if(file_exists($functionsPath))
        {
            $xml = new SimpleXMLElement(file_get_contents($functionsPath));
            
            foreach($xml->function as $function)
            {
                $pluginFunctions[] = array("action" => (string)$function->action,
                                           "description" => (string)$function->description);            
            }
            
        }
        
        $this->set("pluginDescription", $pluginDescription);
        $this->set("pluginFunctions", $pluginFunctions);
    }
    
    /**
    * Display plugins managment page
    */
    function indexAction()
    {                    
        $plugins = $this->getAvailablePlugins();
        $this->set("plugins", $plugins);
    }
} 

?>