<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class Admin_SitemapController extends Controller
{
    function init()
    {        
        $this->acl->allow('administrator', $this->name, "*");
         
        if(!$this->acl->isAllowed($this->session->get("role"), $this->name, $this->action))
        {
            $this->redirect(FrontController::getRewrittedUrl("/admin/main/logIn"));  
        }
    }   
    
    function indexAction()
    {
        $doc = new XmlGenerator();

        $root = new XmlElement('urlset');
        $doc->appendChild($root);
        
        $root->setAttribute('xmlns', 'http://www.sitemaps.org/schemas/sitemap/0.9');
        
        // add static links
		$urlRewriting = Config::get('urlRewriting');
        $siteRootUrl = Config::get('siteRootUrl');
        
		$root->addLink($siteRootUrl, '', 'always', '1.0');
        
        $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/site/news', false), '', 'always', '1.0');
        $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/rss/news', false), '', 'always', '0.8');
        $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/site/topNotes', false), '', '', '0.8');
        $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/site/topHits', false), '', '', '0.8');
        $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/site/topReferrers', false), '', '', '0.8');
        $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/site/topRank', false), '', '', '0.8');
        $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/category/showAll', false), '', 'weekly', '1.0');
        $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/contact', false), '', '', '1.0');

        // add all sites links
        $sites = $this->Site->findAll();
        
        foreach($sites as $site)
        {
            if($site['status'] != 'validated')continue; 

            $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/site/details/' . $site['siteId'] . '/' . $site['siteTitle'], false), date("Y-m-d", strtotime($site['creationDate'])), '', '1.0');
       
        }
		
        // add all categories links
        $categories = $this->Category->findAll();
        
        foreach($categories as $category)
        {
            $root->addLink($siteRootUrl . FrontController::getRewrittedUrl('/site/category/'.$category['categoryId'].'/'.$category['name'].'/1', false), "", '', '1.0');
        }
		
        // save file
        $output = fopen(CODE_ROOT_DIR.'sitemap.xml', "wb");
        $text_xml = utf8_encode($doc->saveXML());
        $success = (fwrite($output, $text_xml) > 0);
    
    }
}