<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class NavigationTree
{
    private $tree;
    private $parents;
    
    function __construct()
    {
        $root_node = array('node_id' => 0, 'childs' => array(), 'value' => array("name" => "Root", "count" => 0));
        $this->tree[0] = $root_node;
        $this->parents[0] =& $this->tree[0]; 
    }
    
    function addNode($node_id, $parent_id, $value)
    {        
        //echo "Add $node_id, $parent_id<br>";
        
        if($this->parents[$parent_id])
        {
            $parent_node =& $this->parents[$parent_id];

            $new_node = array('node_id' => $node_id, 'childs' => array(), 'value' => $value);
            
            $parent_node['childs'][] =& $new_node;
            
            $this->parents[$node_id] =& $new_node;  
        }
        else
        {
            echo "Parent: $parent_id doesn't exists";
        }
    }
    
    function render()
    {
        $node = $this->tree[0];
        $resultList = array();
        $this->renderNode($node, array(), $resultList);
        return $resultList;  
    }
    
    function renderNode($node, $parents, &$resultList, $level = 0)
    {
        $value =& $node['value'];

        if($level > 0)
        {
            $newItem = $value;

            $newItem['parents'] = $parents;
            $parents[] = $newItem; 
            
            $resultList[] = $newItem; 
        }
        
        foreach($node['childs'] as $childNode)
        {
            //echo "next";
            $this->renderNode($childNode, $parents, $resultList, $level + 1); 
        }     
    }
    
    function createSqlNode($node, $level = 0, $parentsChain)
    {
        $value =& $node['value'];
        $out = "";

        $parentsChain[$node['node_id']] = $level;

        foreach($parentsChain as $parentId => $parentLevel)
        {
            $out .= "INSERT INTO categoryparents VALUES($parentId, ".$node['node_id'].", ".($level-$parentLevel).");\r\n"; 
        }

        foreach($node['childs'] as $child_node)
        {
            $out .= $this->createSqlNode($child_node, $level + 1, $parentsChain); 
        }
        
        return $out;     
    }
    
    function createSql()
    {
        $node = $this->tree[0];
        $parentsChain = array();
        return $this->createSqlNode($node, 0, $parentsChain);    
    }
    
    function optionList($node, $option_line, &$results_list, $level = 0)
    {
        $value =& $node['value'];
        
        if($level > 1)
        {
            $option_line .=" > ";
        } 
        
        if($level > 0)
        {
            $option_line .= $value['name'];
            $results_list[$node['node_id']] = $option_line;
        }
        
        foreach($node['childs'] as $child_node)
        {
            $this->optionList($child_node, $option_line, $results_list, $level + 1); 
        }     
    }
    
    function getFullOptionList()
    {
        $node = $this->tree[0];
        $results_list = array();
        $this->optionList($node, "", $results_list);
        return $results_list;    
    }
}

?>