<?php
//////////////////////////////////////////////////////////////////////////////////
//    					 copyright (c) Arfooo Annuaire                          //
//   				 by Hocine Guillaume (c) 2007 - 2008                        //
//       					http://www.arfooo.com/                              //
//    Licence Creative Commons http://creativecommons.org/licenses/by/2.0/fr/   //
//////////////////////////////////////////////////////////////////////////////////

class VoteModel extends Model
{   
    protected $primaryKey = "voteId";
    
    function checkCanVote($remoteIp, $siteId)
    {
        $c = new Criteria();
        $c->add("siteId", $siteId);
        $c->add("remoteIp", $remoteIp);
        $c->add("date > DATE_SUB(NOW(), INTERVAL 24 HOUR)");
        
        return ($this->getCount($c) > 0) ? false : true;
    }
    
    function removeAll()
    {
        $c = new Criteria();
        $this->del($c);
        $this->site->update(array("votesAverage" => 0), $c); 
    }
}

class VoteRecord extends ModelRecord
{
    function save()
    {
        parent::save();

        $c = new Criteria();
        $c->add("siteId", $this->siteId);

        $votesData = Model::factoryInstance("vote")->find($c, "SUM(value) as votesSum, COUNT(*) as votesCount");    
        $votesAverage = $votesData['votesSum'] / $votesData['votesCount']; 
          
        $fields = array('votesAverage' => $votesAverage,
                        'votesCount'   => $votesData['votesCount']); 

        Model::factoryInstance("site")->update($fields, $c);
    } 
}

?>